<?php

//Create Intance of Core Class
//Exit on failure

if (
	file_exists("library/core.classes.php")
	&& (include "library/core.classes.php")
	&& $core = new KB_core("backend")
){}

else {
	header("HTTP/1.1 503 Service Unavailable");
	header("Status: 503 Service Temporarily Unavailable");
	exit(1);
}

// Special case for missing database
if ($core->db === false){

  //Check if database config should be displayed
  if(
    is_empty(fetch("db",$core->core_config())) ||
    (date("U") - $core->filesystem->age(KB_FOLDER."config.json") <= 3600)
  	) {

    //Load database configuration
		$core->template->backend->content(
			$core->template->backend->template("db")
		);

		$core->template->backend->title(
			$core->language->translate(
				"Database Setup"
			)
		);
  }

  else {
      //Display error
      $core->message->set(false);
      $core->message->info("","There was an error connecting to the database");
  }

  //Load backend template and exit
	echo $core->template->backend->template("backend");

	if ($core->refresh)
		$core->refresh();

	exit(0);
}

//Set Session Vars on Request

if ($set_var = $core->get("set_var","get")){
	$core->session->set($set_var, $core->get("set_value","get"));
	$core->refresh(array("set_var"=>"","set_value"=>""));// = true;
}

// User is not signed in

if (!$core->user->backend()) {

	if ($core->runs("rest")) {
		$core->rest->status_code(403);
		$core->rest->send();
	}

	if ($core->get("kit"))
		header("HTTP/1.0 403 Forbidden");

	if (!$core->user->logged_in())
		$core->template->backend->content(
			$core->template->backend->template("login")
		);
}

// User is signed in

else {

	if ($core->get("request")) {
		$core->refresh(array("request"=>""));
	}

	$default_kit_groups = array(
		"tools"		=> "Tools",
	);

  if (not_empty($core->user->data("name"))) {
		$core->template->backend->notice(
			array(
				$core->html->span($core->language->translate("Signed in:")),
				ifttt(
					$core->kit->load("kb_user"),
					$core->html->a($core->user->data("name"),array(
						"href" => $core->url(["kit" => "kb_user", "ID" => $core->user->ID(), "set_group_ID" => $core->user->group->ID(), "do" => "edit"], true)
					)),
					$core->user->data("name")
				),
				$core->html->span($core->language->translate("as")),
				$core->html->span($core->user->group->data("name"))

			)
		);
	}

	//Home as default

	if (neither($core->get("kitgroup"), $core->get("kit"))) {
		$core->template->backend->content(
			$core->template->backend->template("home")
		);

	}

	if ($core->get("kitgroup") && !$core->get("kit")){

		$core->template->backend->content(
			$core->template->backend->template("kitgroup")
		);
		$core->template->backend->title(
			key_fetch("name",$core->kit->data->group->entry($core->get("kitgroup")))
		);
	}

	if ($core->get("kit")) {

		if ($kit = $core->kit->load($core->get("kit"))) {

			$core->template->backend->title(
				$core->language->translate(
					key_of("title", key_of("config",$kit))
				)
			);

			$core->template->backend->content(
				$core->kit->run($kit)
			);
		}

		else{
			$core->refresh(array("kit"=>""));
		}
	}
	$core->template->backend->toolkits($core->kit->toolkits());
}

if ($core->refresh)
	$core->refresh();

echo $core->template->backend->template("backend");

exit(0);