<?php

//Create Intance of Core Class
//Exit on failure

if (
	file_exists('library/core.classes.php') &&
	(include("library/core.classes.php")) &&
	$core = new KB_core("frontend")){}
else {
	header("HTTP/1.1 503 Service Unavailable");
	header("Status: 503 Service Temporarily Unavailable");
	exit(1);
}

$match = "";

if (isset($_SERVER['HTTP_IF_NONE_MATCH']))
	$match = (int) str_replace('"', '', $_SERVER['HTTP_IF_NONE_MATCH']);

$query = $_SERVER['REQUEST_URI'];
$query = urldecode($query);

$path = $core->folder->name($query);
$file = $core->file->name($query);
$filetype = $core->file->type($query);

$frontend_folder = $core->filesystem($core->path("frontend"));
$files_folder = $core->filesystem($core->path("files"));

$paths = array_values(array_filter(explode("/",$path)));

// Query is a captcha
if (fetch("captcha",$paths)) {

	$hash = substr($file, 0 ,strrpos($file, "."));

	$sql = "SELECT * FROM ".DB_PREFIX."kb_tmp WHERE identity = 'captcha' AND value01 = '".$hash."'";
	$result = $core->db->sql_first($sql);

	if(empty($result))
		send_404();

	putenv('GDFONTPATH=' . realpath('./library'));
	$fileTTF =	'forms_captcha';
	fopen(DROOT.LIB_FOLDER."forms_captcha.ttf", "r");
	$size = 30;
	$imgWidth = 170;//200
	$imgHeight = 40;//80
	$im = @imagecreate($imgWidth, $imgHeight);

	$colorBorder = array(255,255,255);
	$colorB = imagecolorallocate($im,hexdec($result['value04'][0].$result['value04'][1]),hexdec($result['value04'][2].$result['value04'][3]),hexdec($result['value04'][4].$result['value04'][5]));
	$colorBG = imagecolorallocate($im,hexdec($result['value03'][0].$result['value03'][1]),hexdec($result['value03'][2].$result['value03'][3]),hexdec($result['value03'][4].$result['value03'][5]));
	imagefill($im, 0,0,$colorBG);

	$mix = range(0,255);
	shuffle($mix);

	$colors=array(
		imagecolorallocate($im,$mix[0],$mix[6],$mix[12]),
		imagecolorallocate($im,$mix[1],$mix[7],$mix[13]),
		imagecolorallocate($im,$mix[2],$mix[8],$mix[14]),
		imagecolorallocate($im,$mix[3],$mix[9],$mix[15]),
		imagecolorallocate($im,$mix[4],$mix[10],$mix[16]),
		imagecolorallocate($im,$mix[5],$mix[11],$mix[17])
	);

	// Zeichnet die Buchstaben und baut den Dateinamen auf
	$next=10;
	for($x=0;$x<4;$x++){

		$angel = rand(-25,25);
		$y = rand($size+5,$imgHeight-5);
		imagettftext($im, $size, $angel, $next, $y, $colors[$x], $fileTTF, $result['value02'][$x]);
		$next += $size + ($imgWidth/$size);
	}

	header("Content-type: image/png");
	imagepng($im);
	exit();
}

// Query calls for a Kit
else if (fetch("kit", $paths)) {

	$key = key(array_find("kit", $paths));
	$kit = key_of(int($key)+1, $paths);
	$paths_sliced = array_slice($paths, int($key)+2);

	$full_path = $core->kit->run($kit, array(
		"query"=>$query,
		"file"=>$file,
		"filetype"=>$filetype,
		"path"=>$path,
		"paths"=>$paths_sliced,
	));

	if(!empty($full_path) and is_file(DROOT.$full_path)) {
		$stat =	stat(DROOT.$full_path);
		if($stat['mtime'] == $match)
			send_match($stat['mtime']);
		else
			send_file(DROOT.$full_path,$stat,$filetype, 1);

	}
	else{
		send_404();
	}

}

// Query is located in files
else {

	// File is a PHP file
	if ($core->file->extension($file) == "php") {

		if ($files_folder->file->exists($path.$file)) {
			// include DROOT.FILES_FOLDER.$query;
			// include DROOT.FILES_FOLDER.$path.$file;
			echo $files_folder->read_php($path.$file, ["core",$core]);
			exit(0);
		}

		if ($frontend_folder->file->exists($path.$file)) {
			// include DROOT.FRONTEND_FOLDER.$path.$file;
			echo $frontend_folder->read_php($path.$file, ["core",$core]);
			exit(0);
		}

		//Should this really be on?
		if ($core->file->exists(DROOT.$path.$file)) {
			// include DROOT.$path.$file;
			exit(0);
		}

	}

	// File exists
	// This should not apply and contradicts .htaccess
	/*
	if ($core->file->exists($query)) {

		$stat =	stat(DROOT.$query);

		if($stat['mtime'] == $match)
			send_match($stat['mtime']);

		else
			send_file(DROOT.$query,$stat,$filetype, 1);
	}

	// File exists in root files folder

	else*/ if($files_folder->file->exists($file)) {

		$stat =	stat($files_folder->get_path($file));

		if($stat['mtime'] == $match)
			send_match($stat['mtime']);
		else
			send_file($files_folder->get_path($file), $stat, $filetype, 1);
	}

	// File couldnt be found yet
	// We let Kits search for it

	else if ($full_paths = $core->kit->run_all("file_handling", array(
		"query"=>$query,
		"file"=>$file,
		"filetype"=>$filetype,
		"path"=>$path,
		"paths"=>$paths,
	))) {

		if (is_empty($full_paths))
			send_404();

		foreach ($full_paths as $full_path) {

			if(is_file($core->path("root").$full_path)) {
				$stat =	stat($core->path("root").$full_path);
				if($stat['mtime'] == $match)
					send_match($stat['mtime']);
				else
					send_file($core->path("root").$full_path,$stat,$filetype, 1);

			}

			else if (is_string($full_path) && not_empty($full_path))
				send_value($full_path, $filetype);

		}
		send_404();

	}

	// No more option left

	else {
		send_404();
	}

}

function send_file($path, $stat, $ftype, $cache) {

	header("Accept-Ranges: bytes");

	if($cache == 1) {
		header('Etag: "'.$stat['mtime'].'"');
		header("Last-Modified: ".date("D, d M Y H:i:s", intval($stat['mtime']))." GMT");
		header("Expires: ".date( 'D, d M Y H:i:s', time()+604800 )." GMT");
		header("Cache-Control:	max-age=604800");
	}
	header("Content-Length: ".$stat['size']);
	header("Content-Type: ".$ftype);
	readfile($path);
	exit(0);
}

function send_value($value, $ftype) {
	header("Accept-Ranges: bytes");
	header("Content-Type: ".$ftype);
	echo $value;
	exit(0);
}

function send_match($ftime){
	header('Etag: "'.$ftime.'"');
	header('Last-Modified: '.gmdate('D, d M Y H:i:s', $ftime).' GMT', true, 304);
	exit(0);
}

function send_404() {
	header("HTTP/1.0 404 Not Found");
	exit();
}


