<?php
class KB_message extends KB_class{

	private $message = [];
	private $info = [];
	private $status = true;
	private $core, $dev;

	function __construct($core) {
		$this->core = $core;
		$this->info		= $this->core->session->get("message.class:info");
		$this->message = $this->core->session->get("message.class:message");
		$this->dev = $this->core->session->get("message.dev");
	}


	// Public

	public function status($set = NULL) {

		if ($set === false)
			$this->status = $set;

		return $this->status;
	}


	public function dev($message = "", $group = "", $error_code = "") {

		if (!is_empty($message))
			$this->dev[$group][] = array($message, int($error_code));

		$this->core->session->set("message.dev",$this->dev);

		return $this->dev;

	}


	public function dev_status() {

		$return = [];
		$groups = [];

		if (is_empty($this->dev))
			return true;

		foreach ($this->dev as $group => $messages)
			foreach($messages as $message)
				if (are_equal(key_of(1,$message),"2"))
					return false;

		return true;
	}


	public function get_dev_messages() {

		$this->core->session->unset_key("message.dev");

		$return = [];
		$groups = [];
		$error_codes_classes = array(""=>"","green","yellow","red");

		if (not_empty($this->dev))
		foreach ($this->dev as $group => $messages) {
			$lines = [];
			$section = [];
			foreach($messages as $message){
				$lines[] = $this->core->html->tag(
					"div",
					array(key_of(0,$message)),
					array("class"=>key_of(key_of(1,$message),$error_codes_classes))
				);
			}
			if (not_empty($group))
				$section = $this->core->html->tag("h5",$group);
			$return[] = $this->core->html->tag("p",array($section,$lines));
		}
		return $return;
	}


	public function set($value = NULL, $message = "") {

		if ($value === NULL)
			return $value;

		if (is_indexed($value)) {
			$return = true;
			foreach ($value as $value_entry) {
				$this->set($value_entry, $message);
				if ($value_entry === false)
					$return = false;
			}
			return $return;
		}

		$value = $this->status($value);

		$identifier = debug_backtrace();

		$this->message(array(
			"status" => $value,
			"message" => htmlspecialchars(substr($this->core->array->implode($message), 0, 600)),
			"file" => $identifier[0]["file"].":".$identifier[0]["line"],
			"time" => $this->core->time(),
		));

		$this->core->session->set("message.class:message",$this->message());
		return $value;
	}


	public function info($true = "Success", $false = "An error occured.") {
		$this->info = array(
			$this->core->language->translate($true),
			$this->core->language->translate($false)
		);
		$this->core->session->set("message.class:info",$this->info);
	}


	public function get_info() {
		$this->core->session->unset_key("message.class:info");
		$this->core->session->unset_key("message.class:message");
		return $this->core->language->translate(ifttt($this->status(), key_of(0,$this->info), key_of(1,$this->info)));
	}


	public function get_message() {
		$this->core->session->unset_key("message.class:info");
		$this->core->session->unset_key("message.class:message");
		$return = [];

		if ($this->message()) {

			if (REST)
				return $this->message();

			foreach ($this->message() as $key => $value) {
				$message = $this->core->html->tag("span",$value["message"], array("class"=>"message"));
				$time = $this->core->html->tag("span",$value["time"], array("class"=>"time"));
				$file = $this->core->html->tag("span",$value["file"], array("class"=>"file"));
				$status = $value["status"];
				$this->status($status);
				$return[] = $this->core->html->tag("p",array(/*$time, */$message, $file), array("class"=>ifttt($status,"green","red")));
			}
			return $return;
		}
	}


	// Private

	private function message($set = false) {

		if ($set !== false)
			$this->message[] = $set;

		return $this->message;
	}


	// Deprecated

	public function get_status()	{
		deprecated("use status instead of get_status()");
		return $this->status();
	}

	public function set_info($true = "Success", $false = "An error occured."){
		deprecated("use info instead of set_info()");
		$this->info($true, $false);
	}

	public function dev_message($message = "", $group = "") {
		deprecated("use dev() instead of dev_message()");
		return $this->dev($message, $group);
	}

}
