<?php

class KB_rest extends KB_class {

	private $core;

	private $output = array();
	private $status_code = 200;

	function __construct($core) {
		$this->core = $core;
	}


	public function add($key = false, $content = NULL) {

		if (is_empty($key))
			return false;

		if ($content === NULL)
			return false;

		if (is_empty(key_of($key,$this->output)))
			$this->output[$key] = $content;

		else if (is_array(key_of($key,$this->output)))
			$this->output[$key][] = $content;

		else
			$this->output[$key] = array(
				$this->output[$key],
				$content
			);
	}


	public function status_code($code=false){

		if($code)
			$this->status_code = $code;

		return $this->status_code;
	}


	private function http_response_code($code=false) {

		switch (int($code)) {

			case 200:
			default:
				return "HTTP/1.0 200 OK";
				break;

			case 201:
				return "HTTP/1.0 201 Created";
				break;

			case 204:
				return "HTTP/1.0 204 No Content";
				break;

			case 400:
				return "HTTP/1.0 400 Bad Request";
				break;

			case 401:
				return "HTTP/1.0 401 Unauthorized";
				break;

			case 404:
				return "HTTP/1.0 404 Not Found";
				break;

			case 405:
				return "HTTP/1.0 405 Method Not Allowed";
				break;
		}
	}


	public function send(){
		// $var = ob_get_clean();
		header($this->http_response_code($this->status_code()));
		header("Content-Type: application/json");
		header("Connection: Closed");

		$return = $this->output;

		if ($message = $this->core->message->get_message())
			$return["message"] = $message;

		if ($info = $this->core->message->get_info())
			$return["info"] = $info;

		echo $this->core->json->encode($return);
		exit(0);
	}


}
