'use strict';

var Slide5 = {};

Slide5.object = {};

Slide5.options = {
	play_delay: 5000,
	// children: "a, img, video",
	children: "*",
	drag_start: "touchstart",
	drag_stop: "touchend touchcancel",
	controls: true,
	dots: true,
	count: true,
	style: "slide"
};

Slide5.timers = {};

var jQuery;

//Init after loaded Dependencies
Slide5.onload = function() {
	jQuery(document).ready(function(){
		Slide5.parse();
	});
}

//Load Dependencies
Slide5.load = function() {

	if (typeof(jQuery) == 'undefined') {

		Slide5.getScript('//code.jquery.com/jquery-1.11.0.min.js', function() {
			Slide5.load();
		});

		return false;
	}

	else {
		Slide5.onload();
	}
}


Slide5.getScript = function (url, success) {

	var script     = document.createElement('script');
	script.src = url;

	var head = document.getElementsByTagName('head')[0],
	done = false;

	// Attach handlers for all browsers
	script.onload = script.onreadystatechange = function() {

		if (!done && (!this.readyState || this.readyState == 'loaded' || this.readyState == 'complete')) {

		done = true;
		// callback function provided as param
		success();
		script.onload = script.onreadystatechange = null;
		head.removeChild(script);

		};
	};
	head.appendChild(script);
};


Slide5.parse = function(){

	jQuery(".slide").each(function(i) {

    Slide5.object[i] = jQuery(this);
		Slide5.object[i].timer = false;
		Slide5.object[i].play = false;
		Slide5.object[i].paused = false;
		Slide5.object[i].index = i;
		Slide5.object[i].attr("index",i);
		Slide5.object[i].current = 0;
		Slide5.object[i].parent = false;
		Slide5.object[i].sub_slide = false;
		Slide5.object[i].options = Object.assign({},Slide5.options);

		var options, option;

		if ((options = Slide5.object[i].attr("data-slide")) !== undefined) {
			options = options.replace(/'/g,"\"");
			options = JSON.parse(options);
		}

		if (typeof options == "object")
			Slide5.object[i].options = Object.assign(Slide5.object[i].options, options);


		if (Slide5.object[i].hasClass("fade"))
			Slide5.object[i].options.style = "fade";

		// Backwards compatibility
		if (option = Slide5.object[i].attr("data-play-delay"))
			Slide5.object[i].options.play_delay = option;

		var parent = Slide5.object[i].parents(".slide").eq(0);

		if (parent)
			Slide5.object[i].parent = Slide5.object[parent.attr("index")];

		if (!Slide5.object[i].parent) {
			Slide5.object[i].on(Slide5.object[i].options.drag_start, function(e){Slide5.startDrag(i,e);});
			Slide5.object[i].on(Slide5.object[i].options.drag_stop, function(e){Slide5.stopDrag(i,e);});
		}

    var children = Slide5.object[i].children(Slide5.object[i].options.children);

		if (Slide5.object[i].options.count)
			Slide5.object[i].count = children.length;

		else
			Slide5.object[i].count = Math.ceil(Slide5.object[i][0].scrollWidth / Slide5.object[i].innerWidth());

		Slide5.object[i].children = children;


    if (children.length > 1) {

			children.addClass("child");

			children.each(function(index) {

				Slide5.object[i].children[index].loaded = true;

				if ($(this).find("img").length > 0)
					Slide5.object[i].children[index].loaded = false;

				$(this).find("img").on("load", function(){
					Slide5.object[i].children[index].loaded = true;
				});

				var child = jQuery(this).find(".slide").eq(0);

				if (index !== 0 && child.hasClass("play")) {
					// Slide5.object[i].sub_slide = child;
					Slide5.object[i].sub_slide = true;
					// child.paused = true;
				}

			});

			if (Slide5.object[i].options.dots) {

	      var slide_dots = jQuery(document.createElement("div")).addClass("dots");

	      for (var j=0; j < Slide5.object[i].count; j++){
					var button = jQuery('<span>',{class:"no-print",j:j}).on("click",function(){Slide5.set(i,jQuery(this).attr("j"))});
	        slide_dots.append(button);
	      }

	      slide_dots.find("span").eq(0).addClass("active");
	      slide_dots.hide();
	      slide_dots.appendTo(Slide5.object[i]).fadeIn(2000);
			}

			if (Slide5.object[i].options.controls) {

				Slide5.object[i].next  = jQuery(document.createElement("div")).addClass("next no-print");
				Slide5.object[i].next.attr("i",i);

	      Slide5.object[i].next.on("touchstart click", function(event){
					event.preventDefault();
					event.stopPropagation();
					event.stopImmediatePropagation();
					// Slide5.debug("next "+i);
					Slide5.next(jQuery(this).attr("i"));
	      });
	      Slide5.object[i].next.appendTo(Slide5.object[i]).fadeIn(2000);
	      Slide5.object[i].prev = jQuery(document.createElement("div")).addClass("prev no-print");
				Slide5.object[i].prev.attr("i",i);
	      Slide5.object[i].prev.on("touchstart click", function(event){
					// Slide5.debug("prev "+i);
					event.preventDefault();
					event.stopPropagation();
					event.stopImmediatePropagation();
	        Slide5.prev(jQuery(this).attr("i"));
	      });
	      Slide5.object[i].prev.appendTo(Slide5.object[i]).fadeIn(2000);
			}

			if (Slide5.object[i].hasClass("play")) {

				Slide5.object[i].play = true;

				if (Slide5.object[i].parent && Slide5.object[i].parent.paused)
					Slide5.object[i].paused = true;

				if (Slide5.object[i].parent && Slide5.object[i].parent.play)
					Slide5.object[i].parent.paused = true;

				Slide5.timer("set", i, function(){Slide5.next(i);});
			}

    }
  });
};


Slide5.timer = function(what, index, func) {

	switch (what) {

		case "set":

			var object = Slide5.object[index];

			if (!object || !object.play)
				return;

			Slide5.timers[index] = func;
			object.timer = setTimeout(function(){Slide5.timer("play", index)}, object.options.play_delay);
			return;
			// break;

		case "pause":

			if (isNaN(index))
				for (var key in Slide5.timers) {
					clearTimeout(Slide5.object[key].timer);
				}

			else
				clearTimeout(Slide5.object[index].timer);

			return;

		case "resume":

			if (isNaN(index))
				for (var key in Slide5.timers) {
					clearTimeout(Slide5.object[key].timer);
					Slide5.timer("play",key);
				}
			else {
				clearTimeout(Slide5.object[index].timer);
				Slide5.timer("play",index);
			}

			return;

		case "unset":
			Slide5.timers[index] = false;
			return;

		default:

			if (isNaN(index) || !Slide5.timers[index])
				return;

			var object = Slide5.object[index];

			if (!object || !object.play)
				return;

			if (object.timer)
				clearTimeout(object.timer);

			if (object.paused)
				return object.timer = setTimeout(function(){Slide5.timer("play",index);}, object.options.play_delay);

			object.timer = setTimeout(function(){Slide5.timer("play",index);}, object.options.play_delay);
			Slide5.timers[index]();
			return;

	}
};


Slide5.next = function(index,next) {

	var object = Slide5.object[index];
	var parent = object.parent;

	if (object.paused)
		return;

  next = typeof next !== 'undefined' ? parseInt(next) : 1;

	var count = object.count;

	if (count <= 1) {
		if (parent && parent.paused) {
			parent.paused = false;
		}
		else {
    	return false;
		}
	}

  var pos = object.current;
  var new_pos = pos + next;

  new_pos = ((new_pos % count) + count) % count;

	if (object.children[new_pos] && object.children[new_pos].complete === false)
		return;

	object.current = new_pos;

	if (new_pos === 0 && parent && parent.paused) {
		object.paused = true;
		// parent = Slide5.object[object.parent.attr("index")];
		parent.paused = false;

		Slide5.timer("play",parent.attr("index"));
	}

	if (object.options.dots) {
		object.find(".dots").children().eq(pos).removeClass("active");
		object.find(".dots").children().eq(new_pos).addClass("active");
	}

	switch (object.options.style) {

		default:
		case "slide":
			var margin = new_pos*-100;
			object.children.eq(0).css("margin-left",margin+"%");
			break;

		case "fade":
			object.children.css("z-index",1);
			object.children.eq(pos).css("z-index",2);
			object.children.eq(new_pos).css("z-index",3).hide().fadeIn();
			break;

	}

	if (object.play && !object.paused) {

		if (object.sub_slide) {

			var child = object.children.eq(pos).find(".slide").eq(0);

			if (child)
				child = child.attr("index");

			if (child) {

				if (Slide5.object[child].count > 1 && Slide5.object[child].play) {
					Slide5.object[child].paused = true;
				}
			}

			child = object.children.eq(new_pos).find(".slide").eq(0);

			if (child)
				child = child.attr("index");

			if (child) {

				if (Slide5.object[child].count > 1 && Slide5.object[child].play) {
					object.paused = true;
					setTimeout(function(){Slide5.object[child].paused = false;},Slide5.object[child].options.play_delay);
				}
			}

		}

		else if (object.children.eq(new_pos).prop("tagName") == "VIDEO") {

			var video = object.children.eq(new_pos);

			setTimeout(function(){video[0].play();},1000);

			video.on("pause", function() {
				if (video[0].currentTime == video[0].duration)
					object.paused = false;
			});

		}

	}
};


Slide5.prev = function(object){
  Slide5.next(object,-1);
};


Slide5.set = function(index,set){

	var object = Slide5.object[index];

	var pos = object.current;

	pos = set - pos;
	// object.current = pos;
  Slide5.next(index,pos);
};


Slide5.startDrag = function(index,event){

	var object = Slide5.object[index];

	// event.preventDefault();
	// event.stopPropagation();
	// event.stopImmediatePropagation();

	if (object.hasClass("drag") === true)
		return;

	// Slide5.debug("startdrag");

	// clearTimeout(Slide5.object[index].play);
	Slide5.timer("pause");

	if(event.originalEvent.touches){
    var touch = event.originalEvent.touches[0];
		object.pos = touch.pageX;
	}else{
		event.preventDefault();
  	object.pos = event.pageX;
	}


	object.margin = parseInt(object.children.eq(0).css("margin-left"));
	// object.current = object.find(".dots").children(".active").index();
	object.save_area = object.innerWidth()/10;
	object.max_drag = object.children.last().position().left;

	object.on("mousemove touchmove", function(event){

		object.addClass("drag");

		object.children.css("pointer-events","none");

		object.on("click", function(e){
			// e.preventDefault();
			// e.stopPropagation();
			// e.stopImmediatePropagation();
		});

		if(event.originalEvent.touches){
	    touch = event.originalEvent.touches[0];
			event.pageX = touch.pageX;
		}

		var new_pos = object.pos-event.pageX;
		if(new_pos > object.max_drag)
			new_pos = object.max_drag;

		var new_margin = object.margin - new_pos;

		if(new_margin > 0)
			new_margin = 0;

		if(object.pos < event.pageX-object.save_area  && new_margin != 0){

			object.new_current = object.current - 1;

			if (object.options.dots) {
				object.find(".dots").children().removeClass("active");
				object.find(".dots").children().eq(object.current-1).addClass("active");
			}
		}
		else if(object.pos > event.pageX+object.save_area){
			object.new_current = object.current + 1;

			if (object.options.dots) {
				object.find(".dots").children().removeClass("active");
				object.find(".dots").children().eq(object.current+1).addClass("active");
			}
		}else{
			if (object.options.dots) {
				object.find(".dots").children().removeClass("active");
				object.find(".dots").children().eq(object.current).addClass("active");
			}
		}

		object.children.eq(0).css("margin-left",new_margin+"px");

	});
};


Slide5.stopDrag = function(index,event){

	var object = Slide5.object[index];

	if (!object.hasClass("drag"))
		return;

	if (object.play)
		object.paused = false;


	// Slide5.debug("stopdrag");

	object.removeClass("drag");
	Slide5.next(object.index,object.new_current - object.current);
	setTimeout(function(){Slide5.timer("resume")}, object.options.play_delay);

	object.children.css("pointer-events","auto");
	object.off("mousemove touchmove");

};


Slide5.debug = function(message) {

	if ($("div.Slide5_message").length == 0) {

		$("<div>", {"class":"Slide5_message"}).text(message).prependTo("body");
	}

	else {
		$("div.Slide5_message").append("<br>").append(message);
	}

	var timeout = window.setTimeout(function(){$(".Slide5_message").fadeOut(500, function(){$(this).remove()})}, 1000);

}

Slide5.load();

