'use strict';

var $core = {};

$core.is_empty = function(object) {

	if (object === null || object === undefined)
		return true;

	switch (typeof object) {

		case "boolean":

			if (object === false)
				return true;

			return false;
			break;

		case "number":
			return false;
			break;

		case "string":
			if (object.length === 0)
				return true;

			return false;
			break;

		case "object":
			if (Array.isArray(object)) {
				if (object.length === 0)
					return true;

				if (Object.values(object).length === 0)
					return true;

				return false;
			}

			else if (object.constructor.name == "Object") {


				if (Object.keys(object).length === 0)
					return true;

				return false;
			}

			else {

				return false;

			}
			break;

		default:
			// if (object === null)
			// 	return true;
			//
			// if (object === undefined)
			// 	return true;

			return false;

	}

	return false;

};


$core.not_empty = function(object) {

	if ($core.is_empty(object))
		return false;

	return true;

}


$core.any_empty = function() {

	for (let object of arguments) {

		if ($core.is_empty(object))
			return true;
	}

	return false;

}


$core.are_empty = function() {

	for (let object of arguments) {

		if ($core.not_empty(object))
			return false;
	}

	return true;

}


$core.either = function() {

	for (var object of arguments) {
		if ($core.not_empty(object))
			return object;
	}

	return object;

}


$core.key_fetch = function(key, object) {

	if ($core.any_empty(key, object))
		return null;

	if (object === undefined)
		return null;

	var $return;

	if ($return = $core.key_of(key, object))
		return $return;

	$return = [];

	for (const [index, value] of Object.entries(object)) {
	  if (typeof value == "object") {
			console.log(value);
			var $fetch = $core.key_fetch(key, value);
			if ($fetch !== null)
				$return.push($fetch);
		}
	}

	if ($core.is_empty(Object.keys($return)))
		return null;

	else if ($return.length > 1)
		return $return;

	else
		return $return.current;

}


$core.key_of = function(key, object) {

	if ($core.any_empty(key, object))
		return null;

	if (object === undefined)
		return null;

	if (object[key] === undefined)
		return null;

	return object[key];

}


$core.ifttt = function(compare, case1, case2) {

	if ($core.is_empty(compare))
		return case2;

	return case1;

}



$core.array = {};


$core.array.clone = function(object) {
	if ($core.is_empty(object))
		return object;
	var new_object = JSON.parse(JSON.stringify(object));
	return new_object;
};


$core.array.move = function(object, from, to) {
	if ($core.any_empty(object, from, to))
		return object;

	object.splice(to, 0, object.splice(from, 1)[0]);
	return object;
};


$core.array.remove = function(object, index) {
	if ($core.any_empty(object, index))
		return object;

	object.splice(index, 1);
	return object;
};


$core.array.trim = function(object) {

	if ($core.is_empty(object))
		return object;

	var return_object = [];

	for (const element of object) {

		if ($core.not_empty(element))
			return_object.push(element);
	}

	return return_object;
};



$core.file = {};


$core.file.name = function(name) {

	if ($core.is_empty(name))
		return name;

	if (typeof name !== "string")
		return name;

	name = name.split("/").slice(-1);
	return name;
};




$core.session = function(key, value) {

	if (key === undefined)
		return null;

	if (value === undefined) {

		value = sessionStorage.getItem(key);

		try {
        var json = JSON.parse(value);
    }

		catch (e) {
        return value;
    }

		return json;

	}

	if (typeof(value) === "object")
		value = JSON.stringify(value);

	sessionStorage.setItem(key, value);
	return $core.session(key);

};
