<?php

//Create Intance of Core Class
//Exit on failure

if(
	file_exists('../library/core.classes.php') &&
	(include("../library/core.classes.php")) &&
	$core = new KB_core("frontend")){}
else{
	header("HTTP/1.1 503 Service Unavailable");
	header("Status: 503 Service Temporarily Unavailable");
	exit(1);
}

$extension = $core->get("extension", "get");

$color = $core->get("color", "get");

$colors = $core->template->icon->config("file_icon_colors");

$color = either(
	$color,
	either(
		key_of(lowercase($extension), $colors),
		"black"
	)
);

$file = DROOT.$core->template->icon->src("document");
$file = $core->folder->name($file).$core->file->name($file);
$file = $core->file->read($file);

$file = preg_replace("/#010101/", $color, $file);

$markup = array(
	$core->xml->rect(array(
		"x"=>"3", "y"=>"7", "width"=>"10", "height"=>"8", "style"=>"fill:$color"
	)),
	$core->xml->text(uppercase($extension), array(
		"x"=>"2", "y"=>"13", "fill"=>"white", "letter-spacing"=>".5", "font-size"=>"5", "font-family"=>"Tahoma","font-weight"=>"bold"
	))
);
$markup = $core->xml->render($markup);

$file = preg_replace("/(<\/svg>)/",$markup."$0", $file);
// $file = base64_encode($file);
// $file = "data:image/svg+xml;base64,".$file;

// return $this->core->html->img($file, $markup);


$hash = hash("crc32", $extension.$color);
header('Etag: "'.$hash.'"');
// header("Last-Modified: ".kb_date("D, d M Y H:i:s", $modified)." GMT");
header('Content-type: image/svg+xml');
echo $file;
exit(0);
