<?php

$kitgroup = $core->kit->data->group->entry(["ID" => $core->get("kitgroup")]);

$menu = [];

$kits_available = $core->kit->installed(true);
$kits = $core->array->filter($kits_available, ["group_ID" => $core->get("kitgroup")]);
/*
$kits = $core->kit->data->read(array(
	"group_ID" => $core->get("kitgroup"),
));
*/

if (key_of("name", $kitgroup) == "System" && ($core->user->is_dev() || $core->config("global_kit_management")))

	$kits[] = array(
		"unique_name"=>"kits",
		"ID"=>"kits",
		"name"=>"Kits",
		"folder" => "kb_standard/kb_kits",
		"run"	=> array(
			"backend" => "backend.php"
		),
		"info_text"	=> $core->user->is_dev() ? "Manage and install Kits. View Kit Store." : "Sharing of Kits",
		"icon" => "kb_kits.svg"
	);

if (is_empty($kits))
	return;

$default_icon = "/".$this->core->folder->path($this->core->path("url"),"core/template/images")."default_kit_icon.svg?version=".$core->file->age($this->core->path()."/core/template/images/default_kit_icon.svg");

foreach ($kits as $kit_index => $value) {

	$core->kit->load(key_of("ID",$value));

	// $run = $core->json->decode(key_of("run", $value));

	// if (!key_of("backend", $run)) {
	if (is_empty(key_of("run", $value))) {
		$kits = remove_keys_of($kit_index,$kits);
		continue;
	}

	$icon_path = either(
		$core->kit->icon($value),
		$default_icon
	);

	$icon = $core->html->span("",[
		"class" => "icon",
		"style" => "background-image: url(".$icon_path.")"
	]);

	$name = key_of("name", $value);
	$name = $core->language->translate($name);
	$name = $core->html->h3($name, ["class" => "title"]);

	if ($info = key_of(["info_text","description"],$value))
		$info = $core->language->translate($info);

	if ($widget = $core->kit->widget(key_of("ID",$value))) {

		$link = "";

		if (key_of("link", $widget))
			$link = $core->html->a(
				[$icon, $name],
				[
					"class" => "kit_link",
					"href" => $core->url(["kit"=>key_of("ID",$value)], true),
					"title" => $info
				]
			);

		$content  = $core->html->div(key_of("content", $widget), ["class"=>"kit_widget_content"]);

		$menu[] = $core->html->div([$link,$content], [
			"class"=>"kit_widget",
			"style" => "grid-column-start: span ".key_of(0, key_of("size", $widget))."; grid-row-start: span ".key_of(1, key_of("size", $widget)).""
		]);

	}

	else {

		$menu[] = $core->html->a(
			[$icon, $name],
			[
				"class" => "kit_link",
				"href" => $core->url(["kit"=>key_of("ID",$value)], true),
				"title" => $info
			]
		);
	}
}


if (count($kits) === 1) {
	$ID = key_fetch("ID", $kits);
	$core->set("kit", $ID);
	$core->template->backend->body(["class"=>"kit_page"]);

}

else {
	$core->template->backend->body(["class"=>"kit_group_page"]);
	echo $core->html->div($menu, ["class" => "kit_group"]);
}
