<?php
//Create backend menu

$kits_available = $core->kit->installed(true);
$kits_in_groups = $core->array->group_by($kits_available, "group_ID");

// Core Kit

$system_menu = [];

if ($core->user->is_dev() || $core->config("global_kit_management"))
	$system_menu[] = array(
		"name" => "Kits",
		"unique_name"=>"kits",
		"folder" => "kb_standard/kb_kits",
		"ID"	=> "kits",
		"run"	=> array(
			"backend" => "backend.php"
		),
		"icon" => "kb_kits.svg"
	);

// Core Kit Group

$system_menu_group = NULL;

foreach ($core->kit->data->group->read() as $group) {

	if (key_of("name", $group) == "System"){
		$system_menu_group = key_of("ID", $group);
		break;
	}

	$system_menu_group = key_of("ID", $group);
}


// Kits


$kitgroups = $core->kit->data->group->read_names();
// $kitgroups = array_find("((?!Start).)*",$kitgroups);

$kits = [];

if ($ID = $core->get("kit")) {

	// $entry = $core->kit->data->entry($ID);
	$entry = $core->kit->installed($ID);

  // Retry, if unique_name is passed
  // if (is_empty($entry))
    // $entry = $core->kit->data->entry(array("unique_name"=>$ID));

	if ($entry) {
		$active_group = $entry["group_ID"];
		// $kits = $core->kit->data->read_per("group_ID",$entry["group_ID"]);
		$kits = $kits_in_groups[$active_group];

		if ($entry["group_ID"] == $system_menu_group && !empty($system_menu))
			$kits = array_merge($system_menu,$kits);
	}
	else if (fetch(array("ID"=>$core->get_var("kit")), $system_menu)) {
		$active_group = $system_menu_group;
		// $kits = $core->kit->data->read_per("group_ID",$system_menu_group);
		$kits = $kits_in_groups[$active_group];
		$kits = array_merge($system_menu,$kits);
	}
}

if (not_empty($kits) && count($kits) > 1)

	foreach($kits as $kit) {

		$core->kit->load(key_of("ID",$kit));

		// $run = $core->json->decode(key_of("run", $kit));

		// if (is_empty(key_of("backend", $run)))
		if (is_empty(key_of("run", $kit)))
			continue;

		$ID = $core->get("kit");
		$active = "";


		if ($ID && either(are_equal(key_of("ID", $kit), $ID), are_equal(key_of("unique_name", $kit), $ID)))
			$active = "active";

		$name = key_of("name", $kit);

		$icon = $core->html->img(either(
			$core->kit->icon($kit),
			"/".$this->core->folder->path($this->core->path("url"),"core/template/images")."default_kit_icon.svg?version=".$core->file->age($this->core->path()."/core/template/images/default_kit_icon.svg")
		));
		$name = $core->language->translate($name);

		$core->template->backend->sub_menu($core->html->tag("a", array($icon, $core->html->span($name,["class"=>"label"])), array(
			"class" => $active,
			"href" => $core->generate_url(array("kit"=>$kit["ID"]),true)
		)));
	}

if (is_empty($kits) && $core->kit->data->read() == false && not_empty($system_menu))
	foreach ($system_menu as $kit) {

		$ID = $core->get_var("kit");

		$core->template->backend->sub_menu(
			$core->html->a(
				$core->html->span($core->language->translate($kit["name"]), ["class"=>"label"]),
				[
					"class" => ifttt(($ID && $kit["ID"] == $ID), "active"),
					"href" => $core->url(array("kit"=>$kit["ID"]),true),
				]
			)
		);
	}

if (not_empty($kitgroups))
	foreach ($kitgroups as $key => $kitgroup)
		// if (is_empty($core->kit->data->read(["group_ID"=>$key])))
		if (is_empty(key_of($key, $kits_in_groups)))
			$kitgroups = remove_keys_of($key,$kitgroups);

if (not_empty($kitgroups) && count($kitgroups) > 1) {

	/*
	$core->template->backend->main_menu(
		$core->html->a(
			$core->language->translate("Overview"),
			[
				"href" => $core->url([],true),
			]
		)
	);
	*/

	foreach ($kitgroups  as $key => $kitgroup) {

		$ID = $core->get("kitgroup");

		$core->template->backend->main_menu(
			$core->html->a(
				$core->language->translate($kitgroup),
				[
					"class" => ifttt(($ID && $key == $ID) || (isset($active_group) && $active_group == $key), "active"),
					"href" => $core->url(["kitgroup"=>$key],true),
				]
			)
		);
	}
}
