<?php

$table = $core->view->table();

$table->new_elements(array(
	"name" => array(
		"markup" => 'style="width:40%"',
		"title" => 'Filename',
	),
	"mtime" => array(
		"markup" => 'style="width:30%"',
		"value" => '$format->datetime($mtime)',
		"title" => 'Date',
	),
	"size" => array(
		"markup" => 'style="width:30%"',
		"value" => '$format->filesize($size)',
		"title" => 'Filesize',
	),
	"tools" => array(
		"value" => 'return_tools($name)',
		"title" => '',
	)
));

$return_tools = function ($name) use ($core) {

	return $core->html->render(array(
		$core->template->kit->button("download", "", array(
			"title"=>"Download Backup",
			"href"=>$core->generate_url(array("do"=>"download","file"=>$name)),
			"class"=>"small button",
		)),
		$core->template->kit->button("load", "", array(
			"title"=>"Restore Backup",
			"href"=>$core->generate_url(array("view"=>"restore", "do"=>"edit" , "file"=>$name)),
			"class"=>"small button",
		)),
		$core->template->kit->button("waste", "", array(
			"title"=>"Delete Backup",
			"href"=>$core->generate_url(array("do"=>"delete","file"=>$name)),
			"class"=>"small button",
		)),
	));
};

$table->config("return_tools",$return_tools);

$backup = $core->filesystem();
$backup->base_dir($core->path()."backup");

$kitbooth = $core->filesystem();
$kitbooth->base_dir($core->path());

$objects = [
	"backup" => $backup,
	"kitbooth" => $kitbooth,
	"table" => $table,
];

$core->filesystem->base_dir($kit["path"]);

if (are_equal($core->get("do"), "download") && $file = $core->get("file"))
	$backup->file->download($file);

if (are_equal($core->get("do"), "delete")) {

	if ($file = $core->get_var("file")){
		$backup->file->delete($file);
		$core->url_options(["file"=>""]);
	}
	$core->url_options(["do"=>""]);
	$core->refresh();
}

$kit_content = [];

switch ($core->get("view")) {

	default:

		switch ($core->get("do")){

			case "backup":

				$kit_content[] = $core->file->read_php("backend/backup_full.php",$objects);
				$kit_content[] = $core->file->read_php("backend/overview_full.php",$objects);
				break;

			default:
				$kit_content[] = $core->file->read_php("backend/overview_full.php",$objects);
				break;
		}
		break;

	case "core_backups":

		switch ($core->get("do")){

			case "backup":

				$kit_content[] = $core->file->read_php("backend/backup_core.php",$objects);
				$kit_content[] = $core->file->read_php("backend/overview_core.php",$objects);
				break;

			default:

				$kit_content[] = $core->file->read_php("backend/overview_core.php",$objects);
				break;
		}
		break;

	case "part_backups":

		switch ($core->get("do")){

			case "edit":

				$kit_content[] = $core->file->read_php("backend/edit_part.php");
				$kit_content[] = $core->file->read_php("backend/overview_part.php",$objects);
				break;

			case "backup":

				$kit_content[] = $core->file->read_php("backend/backup_part.php",$objects);
				$kit_content[] = $core->file->read_php("backend/overview_part.php",$objects);
				break;

			default:

				$kit_content[] = $core->file->read_php("backend/overview_part.php",$objects);
				break;
		}
		break;

	case "restore":

		switch ($core->get("do")){

			case "edit":

				$kit_content[] = $core->file->read_php("backend/restore_edit.php",$objects);
				break;

			case "restore":

				$kit_content[] = $core->file->read_php("backend/restore_execute.php",$objects);
				break;

			default:

				$kit_content[] = $core->file->read_php("backend/restore_upload.php",$objects);
				break;
		}
		break;


}

$menu = array(
	"" => array(
		"title" => "full backup",
	),
	"core_backups" => array(
		"title" => "core backup",

	),
	"part_backups" => array(
		"title" => "part backup",

	),
	"restore" => array(
		"title" => "restore",

	),
);

$menu = $core->template->kit->menu($menu);


echo $core->template->kit->content(
	$menu,
	$kit_content
);

