<?php

$backend_before_includes = function () use ($core, $kit, &$data, &$menu, &$config) {

	// Backwards compatibility
	if (!$core->file->exists($file = $kit["path"]."backend_before_includes.php"))
		$file = $kit["path"]."/extend/backend_before_includes.php";

	$return = $core->file->read_php($file, array(
		"core" => $core,
		"kit" => $kit,
		"data" => $data,
		"config" => $config,
		"menu" => $menu,
	),
	array(
		"config", "menu", "data"
	));

	if ($return) {
		$config = key_of("config", $return);
		$menu = key_of("menu", $return);
		$data = key_of("data", $return);
	}

};

$edit_before_check = function () use ($core, $kit, &$form, &$data, &$entry) {

	// Backwards compatibility
	if (!$core->file->exists($file = $kit["path"]."edit_before_check.php"))
		$file = $kit["path"]."/extend/edit_before_check.php";

	$return = $core->file->read_php($file, array(
		"core" => $core,
		"kit" => $kit,
		"form" => $form,
		"data" => $data,
		"entry" => $entry,
	),
	array(
		"form","data","entry"
	));

	if ($return) {
		$form = key_of("form", $return);
		$data = key_of("data", $return);
	}

};

$overview_before_output = function ()
	use (
		$core,
		$kit,
		&$data,
		&$table,
		&$additional_menu
	) {

	// Backwards compatibility
	if (!$core->file->exists($file = $kit["path"]."overview_before_output.php"))
		$file = $kit["path"]."/extend/overview_before_output.php";

	$return = $core->file->read_php($file,
	[
		"core" => $core,
		"kit" => $kit,
		"table" => $table,
		"data" => $data,
		"additional_menu" => $additional_menu,
	],
	[
		"table",
		"additional_menu",
	]);

	if ($return) {
		$table = key_of("table", $return);
		$additional_menu = key_of("additional_menu", $return);
	}

};

$duplicate_settings = function () use ($core, $kit, &$data, &$form, &$entry, $config) {

	// Backwards compatibility
	if (!$core->file->exists($file = $kit["path"]."duplicate_settings.php"))
		$file = $kit["path"]."/extend/duplicate_settings.php";


	$return = $core->file->read_php($file, array(
		"core" => $core,
		"kit" => $kit,
		"form" => $form,
		"data" => $data,
		"entry" => $entry,
		"config" => $config,
	),
	array(
		"form",
		"entry",
	));

	if ($return) {
		$form = key_of("form", $return);
		$entry = key_of("entry", $return);
	}

};

$toolbar_buttons = function () use ($core) {};