<?php

$search 	= $kit["unique_name"].ifttt($view_groups, "_group")."_data_search";
$pagination = $kit["unique_name"].ifttt($view_groups, "_group")."_data_pagination";
$filter_set = $core->session->kit->get("filter".ifttt($view_groups, "_group"));


$archiving_existst = not_empty(
		key_of("archived",$object->columns())
);

$archiving_available = not_empty(
	either(
		$archiving_existst,
		key_of("archived",$object->db_column_options())
	)
);

if ($archiving_existst) {
	if ($core->session->kit->get("view_archive".ifttt($view_groups, "_group")))
		$filter_set = $core->array->merge($filter_set,["archived"=>"1"]);
	else
		$filter_set = $core->array->merge($filter_set,["archived"=>"0"]);
}

$table = $core->view->table();
$table->identifier .= ifttt($view_groups, "_group_");
$table->identifier .= md5($core->json->encode($core->session->kit->get("filter".ifttt($view_groups, "_group"))));
$set_pagination = $core->form();
$set_search = $core->form();
$format = $core->format;

$object_cache = function($name = NULL, $object = NULL) {

	static $cache = [];

	if (is_null($name))
		return false;

	if (is_null($object))
		return key_of($name, $cache);

	$cache[$name] = $object;

	return $object;

};

// Pagination

$values = [0=>"All",$table->pagination =>$table->pagination ,50=>"50",100=>"100"];

if ($core->get_var($pagination) !== NULL)
	$table->pagination = $core->get($pagination);

$set_pagination->new_elements([
	"pagination" => [
		"type"	=> "select",
		"title"	=> "Entries/Page:",
		"label"	=> $core->template->icon("pagination"),
		"class" => "autosubmit",
		"translate" => true,
		"value"	=>	$table->pagination,
		"values"	=>	$values,
	],
	"submit" => [
		"type"	=> "submit",
	]
]);

if ($set_pagination->check()) {
	$value = $set_pagination->value("pagination");
	$core->set($pagination, $value);
	$core->session->set($pagination, $value);
	$table->pagination = $value;
}

$set_search->new_element("search",[
	// "label"	=> "Search",
	"label"	=> "",
	"value"	=> $core->get($search),
	"markup" => 'class="search"',
	"placeholder" => "Search",
]);

$set_search->new_element("submit",[
	"type"	=> "submit",
	"label"	=> $core->template->icon("zoom"),
	"class"	=> "small button",
]);

if ($set_search->check()) {
	$core->set($search, $set_search->value("search"));
	$core->session->set($search, $set_search->value("search"));
}

$filter_form = $core->form();

if (!$view_groups && is_object($data->group) && $data->group->count())
	$filter_form->new_field("group_ID", [
		"label" => either($options("group_title"),"Group"),
		"type" => "select",
		"values" => $core->array->union([""=>""],$data->group->read_column("name")),
		"class" => "autosubmit",
		"markup" => ["style"=>"max-width:10em"],
	]);

// Setup Overview

$overview_properties = $get_config("overview_properties");
$edit_properties = $get_config("edit_properties");

if (is_empty($overview_properties)) {

	if (not_empty($edit_properties)) {

		foreach ($edit_properties as $column)
			$table->new_element(
				key_of("key", $column), [
					"title" => $core->language->translate(key_of("label", $column)),
					"search" => true,
				]
			);

	}

  else if (not_empty($column_options = $object->db_column_options())) {

		foreach ($column_options as $column => $value) {

			if (is_numeric($column))
				$column = $value;

			$table->new_element(
				$column, [
					"search"		=> true,
				]
			);
		}
	}
}

if (not_empty($overview_properties))
	foreach ($overview_properties as $key => $property) {

		$value = (is_numeric($key) && isset($property["key"])) ? $property["key"] : $key;
		$column = "column_".$key;

		$option = key_of("option",$property);
		$is_filter = in_list("filter", $option);

		if (!is_null(key_of("key", $property))) {

			$edit_property = fetch(["key"=>$property["key"]], $edit_properties);

			if (!are_empty($edit_property, is_array($edit_property)))
				$property = $core->array->concat(
					remove_keys_of(["value"],current($edit_property)),
					$property
				);

		}

		$filter = key_of("filter",$property);
		$has_search = ifttt(any_empty(key_of("key",$property), key_of("search",$property) !== false ), false, true);


		if ($is_filter) {

			// $edit_property = fetch(["key"=>$property["key"]], $edit_properties);

			if (not_empty(key_of("key", $property)))
				$filter_form->new_element($property["key"],[
					"label"	=> $property["label"],
					"type"	=> "select",
					// "values"	=> [""=>""] + (array) either(key_of("values", $property), key_fetch("values", $edit_property)),
					"values"	=> either(key_of("values", $filter), [""=>""] + (array) key_of("values", $property)),
					"class"=> "autosubmit",
					"translate" => true,
					"markup" => ["style"=>"max-width:10em"],
				]);
		}

		else {

			if (is_empty($table->column($column)))
				$table->new_column(
					$column, [
						"title" => $core->language->translate(ifttt(key_of("label", $property) === NULL, $key, key_of("label", $property))),
						"search" => ifttt($has_search, ["var"=>$value,"type"=>"text"]),
						"sort" => array_key_exists("sort",$property) ? $property["sort"] : $value,
						"name" => $value,
						"array" => fetch("array",$property) ? true : false,
						"cell_markup" => 'style="'.fetch("style",$property).'"',
						"value" => either(key_of("value", $property), "$".$value),
					]
				);

			if (not_empty($search_config = key_of("search", $property)) && is_array($search_config)) {

				$table->element[$column]["search"] = $core->array->concat(
					$table->element[$column]["search"],
					$search_config
				);

				$table->element[$column]["search"]["translate"]	= true;

				if (is_empty(key_of("class", $search_config)) && are_equal(key_of("type", $search_config), "select"))
					$table->element[$column]["search"]["class"]	= "autosubmit";

			}
		}

		if (is_empty($type = key_of("type",$property))) {

			if (not_empty($values = key_of("values", $property)))
				$table->element[$column]["values"] = $values;

			if (key_of("translate", $property))
				$table->element[$column]["values"] = $core->language->translate($values);

			continue;
		}



		if ($core->array->match($type, ["radio","select"])) {

			if ($is_filter) {

				// $filter_form->set_element($property["key"],[
				// 	"values"	=> [""=>""] + (array) key_of("values", $property),
				// ]);

				continue;
			}


			if (is_indexed($property["values"], true))
				$property["values"] = array_combine($property["values"], $property["values"]);

			$property["values"] = $core->language->translate($property["values"]);

			$table->column($column, ["values" => $property["values"] ]);

			if (key_of("search", $table->column($column)))
				$table->column($column, ["search" => [
					"type" => "select",
					"markup" => 'class="autosubmit"',
					"values" => either(key_of("values",key_of("search",$property)),key_of("values",$property)),
					"translate" => true,
					"var" => $value,
				]]);

		}

		else if ($core->array->match($type, ["foreign"])) {

			if (any_empty($table_name = key_of(0, key_of("values",$property)), $column_name = key_of(1, key_of("values",$property))))
				continue;

			$object->foreign([
				key_of("key", $property) => $table_name
			]);


			if (either($has_search, $is_filter)) {

				// Create object

				$object_identifier = $table_name.md5(serialize($filter));

				if (!$table_o = $object_cache($object_identifier)) {

					if (matches("_group",$table_name))
						$table_o = $core->data_group($table_name);

					else
						$table_o = $core->data($table_name);

					$table_o->order($column_name);

					if (!matches("_group",$table_name) && $core->db->table->exists($table_name."_group"))
						$table_o->group(true);

					// Apply filters

					$search_options = [
						"spacing" => "&nbsp;&nbsp;&nbsp;",
					];

					if ($table_o->group() && not_empty($filter)) {

						$filter_type = key($filter);
						$filter_value = current($filter);

						$search_options["ID"] = $filter_value;

						if (are_equal($filter_type, "children")) {
							$table_o->filter([$table_o->group() => $filter_value]);
						}

						else if (are_equal($filter_type, "descendant")) {

							if (are_equal($table_o->group(), "group_ID"))
								$table_o->filter([$table_o->group() => $table_o->group->read_children($filter_value)]);
							else
								$table_o->filter(["ID" => key_fetch("ID",$table_o->children($filter_value))]);
						}

					}

					$object_cache($object_identifier, $table_o);
				}

				if ($table_o->group())
					$search_options["group"] = $table_o->group;

				$search_select = $table_o->read_column($column_name, $search_options);
			}

			if ($is_filter) {

				$filter_form->set_element($property["key"],[
					"values"	=> [""=>""] + $search_select,
				]);

				continue;
			}
			// Set sort
			$table->element[$column]["sort"] = [$table->element[$column]["sort"] => $column_name];

			$table->element[$column]["value"] = 'key_of('.$column_name.', '.$table->element[$column]["value"].')';

			if ($has_search) {
				$table->element[$column]["search"]["var"]	= [$table->element[$column]["search"]["var"]=>"ID"];
				$table->element[$column]["search"]["type"]	= "select";
				$table->element[$column]["search"]["markup"]	= 'class="autosubmit"';
				$table->element[$column]["search"]["values"]	= $search_select;
			}

		}

		else if ($property["type"] == "correlation") {

			if (either($has_search, $is_filter)) {

				$filter_form->set_element($property["key"],[
					"type"	=> "checkbox",
					"class" => "dropdown"
				]);

				$table_o = $core->data($property["values"][0]);
				$table_o->order($property["values"][1]);

				if (!any_empty($filter, is_array($filter))) {

					if (preg_match("/_group/",$property["values"][0])) {

						if (are_equal(key($filter), "children"))
							$table_o->filter(["parent_ID" => current($filter)]);

						else if (are_equal(key($filter), "descendant")) {

							$IDs = $table_o->read_children(current($filter));
							$IDs = array_merge(
								[current($filter)],
								$IDs
							);
							$table_o->filter(["parent_ID" => $IDs]);
						}

						$search_select = array_combine(
							$table_o->read_column($property["values"][1],[
								"ID"		=> current($filter)
							]),
							$table_o->read_column($property["values"][1],[
								"spacing" => "&nbsp;&nbsp;&nbsp;",
								"ID"		=> current($filter)
							])
						);
					}

					else {
						$search_select = $table_o->read_column($property["values"][1]);
					}

				}

				else {
					$search_select = array_combine(
						$table_o->read_column($property["key"]),
						$table_o->read_column($property["key"],[
							"spacing" => "&nbsp;&nbsp;&nbsp;",
						])
					);
				}
			}

			if ($is_filter) {

				$filter_form->set_element($property["key"],[
					"values"	=> $search_select,
				]);

				continue;
			}

			if ($has_search) {
				$table->element[$column]["search"]["type"] = "select";
				$table->element[$column]["search"]["values"] = $search_select;
			}
		}

		else if ($property["type"] == "image") {

			$table->column($column,[
				"search" => false,
				"format" => "file_icon"
			]);

		}

		else if ($property["type"] == "group_ID") {

			if (either($has_search, $is_filter))
				$search_select = $data->group->read_column("name",[
					"spacing" => "&nbsp;&nbsp;&nbsp;",
				]);

			if ($is_filter) {

				$filter_form->set_element($property["key"],[
					// "values"	=> $core->array->union([""=>""],$table->element[$column]["search"]["values"]),
					"values"	=> $search_select,
				]);
			}

			else {

				$table->element[$column]["value"] = [$table->element[$column]["value"],$data->group->read_column("name")];

				if ($has_search) {

					$table->element[$column]["search"]  = $core->array->merge(
						$table->element[$column]["search"],
						[
							"type" => "select",
							"values" => $search_select,
							"markup" => 'class="autosubmit"',
						]
					);
				}

			}


		}

		/*

		if (
			not_empty(key_of($column, $filter_set)) ||
			not_empty(key_of($property["key"], $filter_set))
			)
			unset($table->element[$column]);

		if ($core->array->match("hidden", $option))
			unset($table->element[$column]);

		*/

	}


if ($view_groups)
	$table->new_element(
		"count", [
			"title" => "Entries",
			"value" => 'return_count($ID)',
			"markup" => 'style="width: 1em"',
			"cell_markup" => 'style="width: 1em"',
		]
	);



$ID_key = false;

if (isset($table->element["ID"]))
	$ID_key = "ID";

if (($array = fetch(["name"=>"ID"],$table->element)))
	$ID_key = key($array);

if ($ID_key) {
	$table->element[$ID_key]["markup"] = 'style="width: 1em"';
	$table->element[$ID_key]["cell_markup"] = 'style="width: 1em"';
	// Move to first Position in the Table
	$table->element = array_merge([$ID_key=>$table->element[$ID_key]], $table->element);
}

$table->new_row(
	"ID", [
		"value"	=> 'return_tools($ID,$_values)',
		"class" => "hide"
	]
);

// Output Overview
if (not_empty($overview_properties))
foreach($overview_properties as $key => $property){

	$value = (is_numeric($key) && isset($property["key"])) ? $property["key"] : $key;
	$calc_value = isset($property["value"]) ? $property["value"] : "$".$value;

	$column = "column_".$key;

	if (isset($table->element[$column])) {

		if (not_empty(key_of("calc", $property))) {

			$table->element[$column]["value"]  = '$calc->prepare_'.$property["calc"].'('.$calc_value.','.$column.')';
			$table->element[$column]["footer"] = '$calc->output_'.$property["calc"].'('.$column.')';

			if (preg_match("/intermediate/",$property["calc"]))
				$table->element[$column]["search"] = false;
		}

		if (not_empty(key_of("format", $property)) && is_empty(key_of("format", $table->element[$column])))
			$table->element[$column]["format"]  = $property["format"];

		if (not_empty(key_of("format_options", $property)))
			$table->element[$column]["format_options"]  = $property["format_options"];
	}
}


$return_edit = function ($ID, $name) use($core, $user_can) {

	if ($user_can("edit"))
		return $core->html->a($name, ["href" => $core->url(["do"=>"edit","ID"=>$ID])]);

	return $core->html->a($name, ["href" => $core->url(["do"=>"view","ID"=>$ID])]);
};

$table->config("edit",$return_edit);

$return_count = function ($ID) use ($core, $data) {
	return $data->count_per("group_ID", $ID);
};

$table->config("return_count",$return_count);


$return_tools =	function ($ID, $entry) use($core, $user_can, $display, $archiving_available) {

	$return = [];


	if ($user_can("edit")) {

		$return[] = $core->template->kit->small_button("view_document","View", [
			"href" => $core->url(["do"=>"view","ID"=>$ID]),
		]);

		$return[] = $core->template->kit->small_button("edit","Edit", [
			"href" => $core->url(["do"=>"edit","ID"=>$ID]),
			"class" => "doubleclick",
		]);

		$return[] = $core->template->kit->small_button("copy","Duplicate", [
			"href" => $core->url(["do"=>"duplicate","ID"=>$ID]),
		]);

		if ($display("archiving") && $archiving_available)
			$return[] = $core->template->kit->small_button("archive","Archive", [
				"href" => $core->url(["do"=>ifttt(are_equal(key_of("archived", $entry),1), "unarchive", "archive"),"ID"=>$ID]),
			]);

		$return[] = $core->template->kit->small_button("waste","Delete", [
			"href" => $core->url(["do"=>"delete","ID"=>$ID]),
			"class" => "red",
			"attr-confirm" => "Delete entry?"
		]);

	}

	else {

		$return[] = $core->template->kit->small_button("view_document","View", [
			"href" => $core->url(["do"=>"view","ID"=>$ID]),
			"class" => "doubleclick",
		]);
	}

	return $core->html->render($return);
};

$table->config("return_tools",$return_tools);


if (not_empty($filter_form->element))
	$filter_form->new_field("submit", [
		"type" => "submit",
		"value" => "Save"
	]);

if ($filter_form->submit()) {
	$core->session->kit->set("filter".ifttt($view_groups, "_group"),$core->array->trim($filter_form->values()));
	$core->refresh();
}

if (not_empty($filter_set)) {

	$filter_form->set_values($filter_set);

	if (not_empty(key_of("group_ID", $filter_set)))
		$filter_set["group_ID"] = key_fetch("ID", $data->group->children(key_of("group_ID", $filter_set), true));

	$correlation_properties = fetch(["type"=>"correlation"],$overview_properties);

	if (not_empty($correlation_properties))
		$correlation_properties = fetch(["key"=>array_keys($filter_set)],$overview_properties);

	if (not_empty($correlation_properties))
		foreach ($correlation_properties as $correlation_property) {
			$correlation_values = $filter_set[key_of("key", $correlation_property)];

			if (in_list("use_intersect", key_of("option", $correlation_property))) {

				$IDs = "";

				foreach ($correlation_values as $correlation_value) {

					$IDs = $core->array->intersect(
						(array) $core->correlation->get($object->db_table(),false,key_of(0, key_of("values", $correlation_property)),$correlation_value),
						$IDs
					);

				}
			}

			else {
				$IDs = $core->correlation->get($object->db_table(),false,key_of(0, key_of("values", $correlation_property)),$correlation_values);
			}

			$filter_set[$object->key()] = $core->array->merge(
				(array) $IDs,
				(array) key_of($object->key(),$filter_set)
			);


			unset($filter_set[key_of("key", $correlation_property)]);

		}


	$object->filter($filter_set);
	$filter_set = either(
		remove_keys_of(array_keys($object->filter()), $filter_set),
		false
	);

}



if (!$object->cache() && $object->properties()) {

	$entries = $object->read($filter_set);

	if ($view_groups) {
		$entries = $core->array->group_by($entries, $object->group());
		$entries = $core->array->ungroup_by($entries, $object->key());
	}

}


if ($core->get($search)) {

	if ($object->cache()) {

		$object->search(
			array_keys($object->cache->columns()),
			$core->get($search)
		);

	}

	else if (!$object->properties()) {
		$object->search(
			array_keys($object->columns()),
			$core->get($search)
		);
	}

	else {

		$entries = array_find($core->get($search),$entries,"","","i");
	}


}


// Output

if ($view_groups)
	$core->template->backend->title($core->language->translate(either($options("group_title"),$core->kit->title)));
else
	$core->template->backend->title($core->language->translate(either($options("data_title"),$core->kit->title)));

$additional_menu = [];
$table_menu = [];

if ($user_can("edit"))
	$table_menu["edit"] = [
		"title" => ["add","Add Entry"],
		"class" => "green",
		"url_options" => ["ID" => ""],
	];


$additional_menu[] = [

	ifttt(($display("archiving") && $archiving_existst),
		[
			$core->template->kit->button("view_archive","", [
				"title" => "Toggle view archived elements",
				"href" => $core->url(["do"=>"toggle_archive"]),
				"class" => ifttt($core->session->kit->get("view_archive".ifttt($view_groups, "_group")),"active"),
			])
		]
	),

	ifttt(($display("deleted") && $object->versions()),
		[
			$core->template->kit->button("view_deleted","", [
				"title" => "Toggle view deleted elements",
				"href" => $core->url(["do"=>"toggle_deleted"]),
				"class" => ifttt($core->session->kit->get("view_deleted".ifttt($view_groups, "_group")),"active"),
			])
		]
	),

	ifttt(
		$user_can("overview_properties"),
		$core->template->kit->button("columns","", [
			"title" => "Choose Columns",
			"href" => $core->url(["do"=>"overview_properties"]),
		])
	),

	ifttt(
		$user_can("config"),
		$core->template->kit->button("settings","", [
			"href" => $core->url(["do"=>"config"]),
			"title" => "Kit Settings",
		])
	),

	ifttt(
		($display("import_export") && $user_can("edit")),
		$core->template->kit->button("import", "", [
			"href" => $core->url(["do"=>"import"]),
			"title" => "Import data from CSV file",
		])
	),

	ifttt(
		($display("import_export") && $user_can("export")),
		$core->template->kit->button("export", "", [
			"href" => $core->url(["do"=>"export"]),
			"title" => "Export data as CSV file",
		])
	),

];

$additional_menu[] = [

	ifttt($display("search"),
	[
		"form" => [
			"method" => "post",
			$set_search->label("search"),
			$set_search->field("search"),
			$set_search->field("submit"),
		]
	]),

	ifttt($display("set_pagination"),
	[
		"form" => [
			"method" => "post",
			$set_pagination->label("pagination"),
			$set_pagination->field("pagination"),
			$set_pagination->field("submit"),
		]
	]),
];

$overview_before_output();

$additional_menu = $core->array->union([$menu],$additional_menu);
// $additional_menu = $core->array->union($additional_menu,[$menu]);

foreach ($additional_menu as $key => $value) {
	if (not_empty($value))
		$additional_menu[$key] = $core->html->div($value);
}


$table_menu = $core->template->kit->table_menu($table_menu, $additional_menu);

switch($core->get_var("view")){

	case "groups":

		if ($data->group->cache())
			$content = $table->render($data->group->cache);

		else if (!$data->group->properties())
			$content = $table->render($data->group);

		else
			$content = $table->render($entries);

		echo $core->template->kit->content(
			[$table_menu],
			$content
		);
		break;


	default:

		if ($object->versions() && $core->session->kit->get("view_deleted".ifttt($view_groups, "_group"))) {

			$content = $object->deleted();

			if (not_empty($content)) {
				foreach ($content as $index => $entry) {
					$content[$index] = $core->array->merge(
						$core->json->decode(key_of("entry", $entry)),
						[
							"ID" => key_of("ID", $entry),
						]
					);
				}

				$return_tools =	function ($ID) use ($core, $user_can) {

					$return = [];

					if ($user_can("edit"))

						$return[] = $core->template->kit->small_button("Restore", [
							"href" => $core->url(["do"=>"restore","ID"=>$ID]),
						]);

						return $core->html->render($return);
				};
				
				$table->config("return_tools",$return_tools);

				if (is_object($data->group))
					$content = $table->render($content, $core->array->union([""=>["ID"=>NULL]],$data->group->read_structured()));
				else
					$content = $table->render($content);
			}
			else {
				$content = "";
			}





		}

		else {


			if (is_object($data->group) && (!fetch("combined_view",$object->options) || fetch("combined_view_recursive",$object->options))) {

				if ($data->cache() || !$data->properties())
					$content = $table->render($data,$core->array->union([""=>["ID"=>NULL]],$data->group->read_structured()));

				else
					$content = $table->render($entries,$core->array->union([""=>["ID"=>NULL]],$data->group->read_structured()));

			}

			else {

				if ($data->cache())
					$content = $table->render($data->cache);

				else if (!$data->properties())
					$content = $table->render($data);

				else
					$content = $table->render($entries);

			}
		}

		if (not_empty($filter_form->element))
			echo $core->template->kit->panes(
				$core->template->kit->content(
					"Filter",
					$filter_form->render_form(true,["columns"=>1])
				),
				$core->template->kit->content(
					[$table_menu],
					$content
				),
				[
					"switch" => true
				]
			);

		else
			echo $core->template->kit->content(
				[$table_menu],
				$content
			);
}


