<?php

$core->filesystem->base_dir($core->path("frontend").$core->get("folder"));

$folders = $core->folder->read(["files"=>false]);
$files = $core->folder->read(["folders"=>false]);

foreach ($folders as $index => $folder) {
	$folders[$index] = ["name" => $folder];
}

foreach ($files as $index => $file) {
	$files[$index] = ["name" => $file];
}

$table = $core->view->table();

$table->new_column("name",[
	"title" => "",
	"value" => 'select_folder($name)'
]);

$table->new_row("name",[
	"value" => 'actions_folder($name)',
	"class" => "hide",
]);

$select_folder = function($name = "") use($core) {
	return $core->html->a($name, ["href"=>$core->url(["folder"=>$core->get("folder").$name."/"])]);
};

$actions_folder = function($name = "") use($core) {
	return $core->html->render([
		$core->template->kit->small_button("waste", "Delete", ["class"=>"red","href"=>$core->url(["do"=>"delete_folder","delete_folder" => $name])]),
		// $core->template->kit->button("edit",  "Edit",   ["class"=>"small button","href"=>$core->url(["do"=>"folder_properties","folder_properties" => $name])]),
	]);
};

$select_file = function ($name = "") use ($core) {
	return $core->html->a($name, ["href"=>$core->url(["do"=>"edit_file","file"=>$name])]);
};

$actions_file = function ($name = "") use ($core) {
	return $core->html->render([
		$core->template->kit->small_button("waste", "Delete", ["class"=>"red","href"=>$core->url(["do"=>"delete_file","file" => $name])]),
		$core->template->kit->small_button("download", "Download", ["class"=>"green ","href"=>$core->url(["do"=>"download_file","file" => $name])]),
		$core->template->kit->small_button("edit",  "Edit",   ["class"=>"green","href"=>$core->url(["do"=>"edit_file","file" => $name])]),
	]);
};

$table->config([
	"select_folder" => $select_folder,
	"select_file" => $select_file,
	"actions_folder" => $actions_folder,
	"actions_file" => $actions_file,
]);

$breadcrumbs = function() use($core) {

	if (is_empty($folders = $core->get("folder")))
		return;

	$folders = preg_replace("-[^/]+/$-","",$folders);

	return $core->template->kit->button(
		"level_up",
		"",
		[
			"title"=>$core->language->translate("Return to parent folder"),
			"href"=>$core->url(["folder"=>$folders])
		]);

};

$new_folder = function() use($core) {
	return $core->template->kit->button(
		"add_folder",
		"",
		[
			"title"=>$core->language->translate("Create a new folder"),
			"href"=>$core->url(["do"=>"new_folder"])
		]);
};

$new_file = function() use($core) {
	return $core->template->kit->button(
		"add_file",
		"",
		[
			"title"=>$core->language->translate("Create a new file in this folder"),
			"href"=>$core->url(["do"=>"new_file"])
		]);
};

$upload_file = function() use($core) {
	return $core->template->kit->button(
		"load",
		"",
		[
			"title"=>$core->language->translate("Upload a file to this folder"),
			"href"=>$core->url(["do"=>"upload_file"])
		]);
};

$folder_navigation = "";
$folder_navigation_entries = [];

foreach ((array) preg_split("-/-",$core->get("folder")) as $key => $value) {

	if (is_empty($value))
		continue;

	$folder_navigation_entries[] = $value;
	$folder_navigation .= $core->html->a(
		$value,
		[
			"href" => $core->url(["folder"=>implode("/",$folder_navigation_entries)."/"]),
			"class" => "grey",
		]
	)." / ";
}

// printme($folders);

echo $core->template->kit->content(
	[
		$core->html->h3($core->language->translate("Folders")),
		$core->html->div($folder_navigation),
		$core->html->div([$breadcrumbs(),$new_folder()])
	],
	ifttt($folders,$table->render($folders),$core->html->div())
);

$table->set_column("name",[
	"value" => '$name'
]);

$table->new_row("name",[
	"value" => 'actions_file($name)',
	"class" => "hide",
]);

echo $core->template->kit->content(
	[
		$core->html->h3($core->language->translate("Files")),
		$core->html->div([$new_file(),$upload_file()])
	],
	ifttt($files,$table->render($files),$core->html->div())
);