<?php

$publish_kit = false;

if ($ID = $core->get("ID")) {

	$publish_kit = $core->kit->load($ID, false, false);

	if (is_empty($publish_kit))
		return;
}

else if ($path = $core->get("path")) {

	$config = $core->file->read_php($core->path("root", "kits").$path."release.php","","config");

	if (is_empty($config))
		return;

	$publish_kit = [
		"name" => key_of("title", $config),
		"unique_name" => preg_replace(array("/\//","/_$/"),array("_",""),$path),
		"folder" => $path,
		"path" => DROOT.KITS_FOLDER.$path,
		"config" => array(
			"icon" => key_of("icon", $config),
		),
	];
}


$url = "http://kitbooth.com/pages/kit-store-owner.html?username=".$core->user->user_data("name")."&password=".$core->get_var("kitstore")."&do=api&view=groups";
$kit_in_store = file_content($url);
$kit_in_store = $core->json->decode($kit_in_store);

$kit_in_store = $core->array->filter_by($kit_in_store,"name",$publish_kit["unique_name"]);

if (is_empty($kit_in_store))
  $kit_in_store = ["display_name" => $publish_kit["name"]];

else
  $kit_in_store = current($kit_in_store);


$icon = key_of("icon", key_of("config", $publish_kit));

if (is_empty($icon) && $core->file->exists(key_of("path", $publish_kit)."icon.svg"))
	$icon = "icon.svg";


$form = $core->form();

$form->new_element("display_name", [
  "value"=>key_of("display_name",$kit_in_store),
  "label"=>"Name",
]);

$form->new_element("description", [
  "value"=>key_of("description",$kit_in_store),
  "label"=>"Description",
  "type"=>"textarea",
  "markup"=>'style="min-height: 5em; max-height: 12em; width: 20em"',
]);

$form->new_element("images", [
  "value"=>key_of("images",$kit_in_store),
  "label"=>"Images",
  "type"=>"file"
]);

$form->new_element("price", [
  "value"=>key_of("price",$kit_in_store),
  "label"=>"Price",
]);

$form->new_element("publication", [
  "label"=>"Publishing",
  "type"=>"select",
  "value"=>key_of("publication",$kit_in_store),
  "values"=>array("public","private")
]);

$form->new_element("remarks", [
  "label"=>"Version Remarks",
  "type"=>"textarea",
  "markup"=>'style="height: 16em; width: 30em"',
]);

$form->new_element("submit", [
  "type"=>"submit",
  "value"=>"Publish",
  "markup"=>'class="green"',
]);


if ($form->submit()) {

	$kits_fs = $core->filesystem($core->path("kits"));

  $path = $publish_kit["folder"];

  $version = $kits_fs->file->read($publish_kit["folder"]."/version.txt");
  $kits_fs->file->delete($publish_kit["folder"]."/version.txt");


  $kits_fs->folder->create(".temp");

  $filename = $publish_kit["unique_name"]."_".date("ymd");

  $kits_fs->folder->zip($path,".temp/".$filename, ["include_path" => true]);

	$multipart_boundary = '--------------------------'.microtime(true);

  $postdata = "--$multipart_boundary\r\n".
            "Content-Disposition: form-data; name=\"file\"; filename=\"".$filename.".zip"."\"\r\n".
            "Content-Type: application/zip\r\n\r\n".
            $kits_fs->file->read(".temp/".$filename.".zip")."\r\n";

	if (not_empty($icon))
  $postdata .= "--$multipart_boundary\r\n".
            "Content-Disposition: form-data; name=\"icon\"; filename=\"".$icon."\"\r\n".
            "Content-Type: ".$core->file->type($icon)."\r\n\r\n".
            $kits_fs->file->read(key_of("path", $publish_kit).$icon)."\r\n";

  $postdata .= "--$multipart_boundary\r\n".
            "Content-Disposition: form-data; name=\"username\"\r\n\r\n".
            $core->user->data("name")."\r\n";

  $postdata .= "--$multipart_boundary\r\n".
            "Content-Disposition: form-data; name=\"password\"\r\n\r\n".
            $core->get("kitstore")."\r\n";

  $postdata .= "--$multipart_boundary\r\n".
            "Content-Disposition: form-data; name=\"unique_name\"\r\n\r\n".
            $publish_kit["unique_name"]."\r\n";

  $postdata .= "--$multipart_boundary\r\n".
            "Content-Disposition: form-data; name=\"display_name\"\r\n\r\n".
            $form->value("display_name")."\r\n";

  $postdata .= "--$multipart_boundary\r\n".
            "Content-Disposition: form-data; name=\"publication\"\r\n\r\n".
            $form->value("publication")."\r\n";

  $postdata .= "--$multipart_boundary\r\n".
            "Content-Disposition: form-data; name=\"description\"\r\n\r\n".
            $form->value("description")."\r\n";

  $postdata .= "--$multipart_boundary\r\n".
            "Content-Disposition: form-data; name=\"remarks\"\r\n\r\n".
            $form->value("remarks")."\r\n";

  $postdata .= "--$multipart_boundary\r\n".
            "Content-Disposition: form-data; name=\"price\"\r\n\r\n".
            $form->value("price")."\r\n";

  $postdata .= "--$multipart_boundary\r\n".
            "Content-Disposition: form-data; name=\"svn\"\r\n\r\n".
            $core->version("release")."\r\n";

  $postdata .= "--$multipart_boundary\r\n".
            "Content-Disposition: form-data; name=\"framework\"\r\n\r\n".
            $core->version("framework")."\r\n";

  $postdata .= "--$multipart_boundary\r\n".
            "Content-Disposition: form-data; name=\"core\"\r\n\r\n".
            $core->version("compatibility")."\r\n";

  $postdata .= "--$multipart_boundary--\r\n";

  $opts = ['http' =>
    [
      'method' => 'POST',
      'header' => 'Content-Type: multipart/form-data; boundary='.$multipart_boundary,
      'content' => $postdata
    ]
  ];


  $context  = stream_context_create($opts);


  $url = 'http://kitbooth.com/pages/kit-store-publish.html';
  $result = file_get_contents($url, false, $context);
	$result = $core->json->decode($result);
  $kits_fs->folder->delete(".temp");

	if (key_of("status",$result) === true){
    $core->message->set(true);
    $core->message->info("Veröffentlichung erfolgreich.");
		if($version = key_fetch("version",key_fetch("data",$result))){
			$kits_fs->file->create($publish_kit["folder"]."/version.txt","",$version);
		}

  }
  else{
    $core->message->set(false);
    $core->message->set_info("",key_fetch("message",$result));
  }

  $core->refresh(array("do"=>""));
}

echo $core->template->kit->panel(
	"Publishing Information",
	$core->template->kit->tabs([
		"Kit" => [
			$form->render([
				"display_name",
				"description",
				"images",
				"price",
				"publication"
			])
		],
		"Version Remarks" => $form->field("remarks"),
		ifttt($icon, "Icon") => ifttt($icon, $core->html->article($core->html->img(
			"/".KITS_FOLDER.key_of("folder", $publish_kit)."/".$icon."?version=".$core->file->age(DROOT.KITS_FOLDER.key_of("folder", $publish_kit)."/".$icon),
			array("style"=>"width:48px")
		)))
	]),
	[
		$form->field("submit"),
		$core->template->kit->button("Cancel", ["href"=>$core->url(["do"=>"","ID"=>"", "path"=>""])])
	],
	[
		"wrap_form" => $form,
		"footer" => ["class" => "fill"]
	]
);
